// dirent.h - for WIN32
#ifndef _win_dirent_h_
#define _win_dirent_h_

#include <sys/types.h>
#include <sys/stat.h>
#include <direct.h>
#include <io.h>

#ifdef __cplusplus 
extern "C" {
#endif

struct dirent
{
    long            d_ino;      // 0
    unsigned short  d_reclen;   // 0
    unsigned short  d_namlen;
    char *          d_name;
};

typedef struct
{
    struct _finddata_t dd_dta;
    struct dirent     dd_dir;
    long              dd_handle;
    int               dd_status;
    char              dd_name[1];
} DIR;

extern DIR * opendir(char * path);
extern struct dirent * readdir(DIR * dirp);
extern int closedir(DIR * dirp);

#ifdef __cplusplus 
}
#endif

#endif // #ifndef _win_dirent_h_
// eof - dirent.h

