// config.h
// Hand crafted for MSVC
#ifndef _config_h_
#define _config_h_
#define CONFIG_H_INCLUDED

#define HAVE_WINSOCK2_H 1

// at some stage must define HAVE_THREADS - CHECKME!!! ***TBD***
#ifdef __cplusplus
#define USE_CHECKED_ALLOCZ2 // a version with 'type' given first
#else
#undef USE_CHECKED_ALLOCZ2 // a version with 'type' given first
#endif

// 20080910 - in compiling libswscale, need HAVE_VIRTUALALLOC
#define HAVE_VIRTUALALLOC 1

#pragma warning(disable: 4244) // say: conversion from 'double' to '__int64', possible loss of data
#pragma warning(disable: 4305) // 'initializing' : truncation from 'double' to 'const float'
#pragma warning(disable: 4018) // signed/unsigned mismatch
#pragma warning(disable: 4090) // different 'const' qualifiers
#pragma warning(disable: 4334) // result of 32-bit shift implicitly converted to 64 bits (so what?)
#pragma warning(disable: 4146) // unary minus operator applied to unsigned type, result still unsigned - CHECKME!!!
#pragma warning(disable: 4101) // unreferenced local variable
#pragma warning(disable: 4047) // like : 'initializing' : 'int16_t (*)[2]' differs in levels of indirection from 'int16_t *'
#pragma warning(disable: 4028) // like : formal parameter 1 different from declaration
#ifdef __cplusplus 
//#pragma message("__cplusplus is defined - some added warnings disabled")
#pragma warning(disable: 4804) // like: '>>' : unsafe use of type 'bool' in operation
#pragma warning(disable: 4806) // like: '&' : unsafe operation: no value of type 'bool' promoted to type 'int' can equal the given constant
#pragma warning(disable: 4309) // like: '=' : truncation of constant value
#else
//#pragma message("ERROR: __cplusplus is NOT defined")
//#pragma message("These libraries MUST be compiled as C++ (/TP)")
//.error Can NOT continue...
#endif

#include "conf.h"      // switch on just about everything ;=))

#include <Winsock2.h>
extern int gettimeofday(struct timeval * tp, void * tzp);

#ifndef _INC_FLOAT
#include <float.h>	// for _isnan, and DBL_MAX value
#endif
#define isinf(x) (((x) > DBL_MAX) || ((x) < DBL_MAX))
// _isnan
#define isnan _isnan

// needs <io.h> to define
#include <io.h> // for _open, _read, etc

#define inline __inline
#define snprintf _snprintf
#define tempnam _tempnam
#define open _open
#define read _read
#define write _write
#define close _close
#define lseek _lseek
#define strtoll _strtoui64
#define strncasecmp _strnicmp
#define strcasecmp _stricmp

// need atoll(ptr)
#define atoll(a) _strtoui64(a,NULL,10)

// can NOT do this because it upsets stdlib.h ;=(( so must be on a case by case basis
// #undef restrict
// #define restrict __restrict

//extern double rint(double d);
#define rint(x) (( x > 0.0 ) ? floor( x + 0.5 ) : ( x < 0.0 ) ? ceil( x - 0.5 ) : 0.0 )

// functions
// cube root functions
extern float cbrtf(float x);
extern double cbrt(double x);

#ifndef M_ALLOC
#define M_ALLOC(a) calloc(1,a)
#define M_FREE(a)  free(a)
#endif

#define INT64_C(a)      (__int64)a   // try this - CHECKME!!! - should be 64 bits
#define UINT64_C(a)     (unsigned __int64)a   // try this - CHECKME!!! - should be 64 bits

#endif // #ifndef _config_h_
// eof - config.h
